﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Text;

namespace Chart_GettingStarted
{
    public class ViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<Model> lineData1;
        public ObservableCollection<Model> LineData1
        {
            get { return lineData1; }

            set
            {
                lineData1 = value;
                RaisePropertyChanged("LineData1");
            }
        }

        private ObservableCollection<Model> data;
        public ObservableCollection<Model> Data
        {
            get { return data; }

            set
            {
                data = value;
                RaisePropertyChanged("Data");
            }
        }

        public ViewModel()
        {
            LineData1 = new ObservableCollection<Model>();
            LineData1.Add(new Model(new DateTime(2019, 07, 05), 21));
            LineData1.Add(new Model(new DateTime(2019, 07, 06), 24));
            LineData1.Add(new Model(new DateTime(2019, 07, 07), 36));
            LineData1.Add(new Model(new DateTime(2019, 07, 08), 38));
            LineData1.Add(new Model(new DateTime(2019, 07, 09), 54));
            LineData1.Add(new Model(new DateTime(2019, 07, 10), 57));
            LineData1.Add(new Model(new DateTime(2019, 07, 11), 70));

            Data = new ObservableCollection<Model>();
            Data.Add(new Model(0, 1));
            Data.Add(new Model(1, 1));            
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }        
    }

    public class Model : INotifyPropertyChanged
    {
        private DateTime date;
        public DateTime Date
        {
            get { return date; }
            set
            {
                if(value != date)
                {
                    date = value;
                    RaisePropertyChanged("Date");
                }
            }
        }

        private double xValue;
        public double XValue
        {
            get { return xValue; }
            set
            {
                if (value != xValue)
                {
                    xValue = value;
                    RaisePropertyChanged("XValue");
                }
            }
        }

        private double yValue;
        public double YValue
        {
            get { return yValue; }
            set
            {
                if (value != yValue)
                {
                    yValue = value;
                    RaisePropertyChanged("YValue");
                }
            }
        }

        public Model(DateTime date, double yValue)
        {
            this.Date = date;
            this.YValue = yValue;
        }

        public Model(double xValue, double yValue)
        {
            this.XValue = xValue;
            this.YValue = yValue;
        }
                
        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            if(PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
